source('CFU_EOF.txt')
library(s2dverification)

nt=3
ny=5
nx=4
neofs=min(nt,nx*ny)
a=array(rnorm(nt*ny*nx),dim=c(nt,ny,nx))
a=a-InsertDim(Mean1Dim(a,1),1,nt)
lon=c(20,25,30,35)
lat=c(20,25,30,35,40)

# Weight computation
#wgt=array(cos(lat*pi/180),dim=c(ny,nx))
#wgt <- wgt/sum(wgt,na.rm=T)
##wgt <- sqrt(wgt)

#Within CFU_EOF
b=CFU_EOF(lon,lat,a,neofs=neofs)

#Without CFU_EOF
#abis=array(a*InsertDim(wgt,1,nt),dim=c(nt,ny*nx))
#b=La.svd(abis)
#EOF=array(b$v,dim=c(neofs,ny,nx))
#PC=b$u

test=array(0,dim=dim(a))
for (i in 1:nt) {
  for (j in 1:neofs) {
    # Check within CFU_EOF
    #test[i,,]=test[i,,]+b$PCs[i,j]*b$EOFs[j,,]*b$D[j]/wgt
    #test[i,,]=test[i,,]+b$PCs[i,j]*b$EOFs[j,,]/wgt # new PC normalization
    test[i,,]=test[i,,]+b$PCs[i,j]*b$EOFs[j,,] # new EOF and PC normalization

    # Check without CFU_EOF
    #test[i,,]=test[i,,]+PC[i,j]*EOF[j,,]*b$d[j]/wgt  # Check without CFU_EOF
  }
}

print("The difference below should be of the order of the machine precision:")
print(max(abs(test-a)))
